﻿using System;
using System.Collections.Generic;
using System.Windows.Controls;

namespace ClientSGD.Accions
{
    class Carrec
    {
        private Int32 id;
        private int? permisos_id;
        private string nom;
        private Permisos permisos;

        #region Metode constructor
        /*
         * Constructor
         */
        public Carrec(Int32 id, string nom, int? permisos_id)
        {
            this.id = id;
            this.nom = nom;
            this.permisos_id = permisos_id;
        }
        #endregion

        #region Metodes d'acces
        public Int32 CarrecId
        {
            get { return id; }
        }

        public String CarrecNom
        {
            get { return nom; }
        }

        public int? PermisosId
        {
            get { return permisos_id; }
        }
        #endregion

        #region Recuperar o establir permisos
        public Permisos Permisos
        {
            get { return permisos; }
            set { permisos = value; }
        }
        #endregion

        #region Preparar vista de carrecs habilitats
        /*
         * Metode que carrega el llistat de carrecs habilitats a un StackPanel
         */
        public static StackPanel llistaCarrecsHabilitats(List<ServeiWeb.Carrec> llistaCarrecs)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaCarrecs.Count; cont++)
            {
                VistaSeleccioCarrec vistaCarrec = new VistaSeleccioCarrec();
                vistaCarrec.blockId.Text = llistaCarrecs[cont].Id.ToString();
                vistaCarrec.blockCarrec.Text = "Nom: " + llistaCarrecs[cont].Nom.ToString();
                string permisos = "Permisos: <<Sense permisos>>";
                if (!llistaCarrecs[cont].NomPermisos.Equals(string.Empty))
                {
                    permisos = llistaCarrecs[cont].NomPermisos;
                }
                vistaCarrec.blockPermisos.Text = permisos;
                stack.Children.Add(vistaCarrec);
            }
            return stack;
        }
        #endregion

        #region Carrecs habilitats seleccionats
        /*
         * Metode que revisa els carrecs habilitats seleccionats i retorna un llistat dels seus id
         */
        public static List<Int32> carrecsHabilitatsSeleccionats(ScrollViewer scrollCarrecs)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollCarrecs.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaSeleccioCarrec vistaCarrec = new VistaSeleccioCarrec();
                vistaCarrec = (VistaSeleccioCarrec)stack.Children[cont];
                if (vistaCarrec.checkCarrec.IsChecked != null && (bool)vistaCarrec.checkCarrec.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaCarrec.blockId.Text));
                }
            }
            return llista;
        }
        #endregion

        #region Preparar vista de carrecs existents
        /*
         * Metode que carrega el llistat de carrecs a un StackPanel
         */
        public static StackPanel llistaCarrecs(List<ServeiWeb.Carrec> llistaCarrecs)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaCarrecs.Count; cont++)
            {
                VistaCarrec vistaCarrec = new VistaCarrec();
                vistaCarrec.blockId.Text = llistaCarrecs[cont].Id.ToString();
                vistaCarrec.blockNom.Text = "Nom: " + llistaCarrecs[cont].Nom.ToString();
                string habilitat = "Habilitat: No";
                if (llistaCarrecs[cont].Habilitat)
                {
                    habilitat = "Habilitat: Si";
                }
                vistaCarrec.blockHabilitat.Text = habilitat;
                string nomPermisos = "Permisos: <Sense permisos>";
                if (!llistaCarrecs[cont].NomPermisos.Equals(string.Empty))
                {
                    nomPermisos = "Permisos: " + llistaCarrecs[cont].NomPermisos.ToString();
                }
                vistaCarrec.blockPermisos.Text = nomPermisos;
                stack.Children.Add(vistaCarrec);
            }
            return stack;
        }
        #endregion

        #region Carrecs seleccionats
        /*
         * Metode que revisa els carrecs seleccionats i retorna un llistat dels seus id
         */
        public static List<Int32> carrecsSeleccionats(ScrollViewer scrollCarrecs)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollCarrecs.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaCarrec vistaCarrec = new VistaCarrec();
                vistaCarrec = (VistaCarrec)stack.Children[cont];
                if (vistaCarrec.checkCarrec.IsChecked != null && (bool)vistaCarrec.checkCarrec.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaCarrec.blockId.Text));
                }
            }
            return llista;
        }
        #endregion
    }
}
