﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace ClientSGD.Accions
{
    class Despesa
    {
        #region Preparar vista de despeses
        /*
         * Metode que donat un llistat de despeses,retorna el llistat a un StackPanel
         */
        public static StackPanel llistaGridDespeses(List<ServeiWeb.Despesa> llistaDespeses)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaDespeses.Count; cont++)
            {
                VistaGestioDespesa vista = new VistaGestioDespesa();
                vista.blockId.Text = llistaDespeses[cont].Id.ToString();
                vista.blockData.Text = "Data: " + llistaDespeses[cont].Data.ToString("dd/MM/yyyy");
                vista.blockImport.Text = "Import: " + llistaDespeses[cont].Import.ToString();
                vista.blockTipus.Text = "Tipus: " + llistaDespeses[cont].NomTipus.ToString();
                string adjunt = "Adjunt: No";
                if (llistaDespeses[cont].Adjunt)
                {
                    adjunt = "Adjunt: Si";
                }
                vista.blockAdjunt.Text = adjunt;
                vista.blockComentari.Text = "Comentari: " + llistaDespeses[cont].Comentari;
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Llista de despeses seleccionades
        /*
         * Metode que revisa les despeses seleccionats i retorna un llistat dels seus id
         */
        public static List<Int32> despesesSeleccionades(ScrollViewer scrollDespesesPendents)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = (StackPanel)scrollDespesesPendents.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaGestioDespesa vistaDespesa = new VistaGestioDespesa();
                vistaDespesa = (VistaGestioDespesa)stack.Children[cont];
                if (vistaDespesa.checkDespesa.IsChecked != null && (bool)vistaDespesa.checkDespesa.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaDespesa.blockId.Text));
                }
            }
            return llista;
        }
        #endregion

        #region Llista per verificar adjunts a despeses
        /*
         * Metode que verifica les despeses que tenen adjunt,retorna el llistat a un StackPanel
         */
        public static List<bool> despesesAmbAdjunt(ScrollViewer scrollDespeses)
        {
            List<bool> llistaAdjunts = new List<bool>();
            StackPanel stack = (StackPanel)scrollDespeses.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaGestioDespesa vistaDespesa = new VistaGestioDespesa();
                vistaDespesa = (VistaGestioDespesa)stack.Children[cont];
                if (vistaDespesa.blockAdjunt.Text.Equals("Adjunt: Si"))
                {
                    llistaAdjunts.Add(true);
                }
                else
                {
                    llistaAdjunts.Add(false);
                }
            }
            return llistaAdjunts;
        }
        #endregion

        #region Preparar vista de despeses pendents
        /*
         * Metode que revisa les despeses d'un full pendent de validar seleccionats i retorna un llistat dels seus id
         */
        public static StackPanel llistaGridDespesesPendents(List<ServeiWeb.Despesa> llistaDespeses, List<DateTime> llistaDates)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaDespeses.Count; cont++)
            {
                VistaDespesesFullPendent vista = new VistaDespesesFullPendent();
                if (llistaDates.Contains(llistaDespeses[cont].Data))
                {
                    vista.LayoutRoot.Background = new SolidColorBrush(Colors.Green);
                    vista.Foreground = new SolidColorBrush(Colors.LightGray);
                }
                vista.blockId.Text = llistaDespeses[cont].Id.ToString();
                vista.blockData.Text = "Data: " + llistaDespeses[cont].Data.ToString("dd/MM/yyyy");
                vista.blockImport.Text = "Import: " + llistaDespeses[cont].Import.ToString();
                if (llistaDespeses[cont].Acceptada == null || llistaDespeses[cont].Acceptada == true)
                {
                    vista.blockEstat.Text = "Estat: Acceptada";
                }
                else
                {
                    vista.blockEstat.Text = "Estat: Denegada";
                }
                if (llistaDespeses[cont].Adjunt)
                {
                    vista.blockAdjunt.Text = "Adjunt: Si";
                }
                else
                {
                    vista.blockAdjunt.Text = "Adjunt: No";
                }
                vista.blockTipus.Text = "Tipus: " + llistaDespeses[cont].NomTipus.ToString();
                if (llistaDespeses[cont].Comentari.Length > 0)
                {
                    vista.blockComentaris.Text = "Comentaris: Si";
                }
                else
                {
                    vista.blockComentaris.Text = "Comentaris: No";
                }
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Despeses pendents seleccionades
        /*
         * Metode que revisa les despeses seleccionades d'un full pendent de validar i retorna un llistat dels seus id
         */
        public static List<Int32> despesesPendentsSeleccionades(ScrollViewer scrollDespeses)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollDespeses.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaDespesesFullPendent vistaDespesa = new VistaDespesesFullPendent();
                vistaDespesa = (VistaDespesesFullPendent)stack.Children[cont];
                if (vistaDespesa.checkDespesa.IsChecked != null && (bool)vistaDespesa.checkDespesa.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaDespesa.blockId.Text));
                }
            }
            return llista;
        }
        #endregion

        #region Preparar vista de despeses tancades
        /*
         * Metode que donat un llistat de despeses d'un full tancat,retorna el llistat a un StackPanel
         */
        public static StackPanel llistaGridDespesesTancades(List<ServeiWeb.Despesa> llistaDespeses)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaDespeses.Count; cont++)
            {
                VistaDespesesFullTancat vista = new VistaDespesesFullTancat();
                vista.blockId.Text = llistaDespeses[cont].Id.ToString();
                vista.blockData.Text = "Data: " + llistaDespeses[cont].Data.ToString("dd/MM/yyyy");
                vista.blockImport.Text = "Import: " + llistaDespeses[cont].Import.ToString();
                if (llistaDespeses[cont].Adjunt)
                {
                    vista.blockAdjunt.Text = "Adjunt: Si";
                }
                else
                {
                    vista.blockAdjunt.Text = "Adjunt: No";
                }
                if (llistaDespeses[cont].Acceptada == null || llistaDespeses[cont].Acceptada == true)
                {
                    vista.blockEstat.Text = "Estat: Acceptada";
                }
                else
                {
                    vista.blockEstat.Text = "Estat: Denegada";
                }
                vista.blockTipus.Text = "Tipus: " + llistaDespeses[cont].NomTipus.ToString();
                string comentari = "Comentari: No";
                if (llistaDespeses[cont].Comentari.Length > 0)
                {
                    comentari = "Comentari: Si";
                }
                vista.blockComentari.Text = comentari;
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Despeses tancades seleccionades
        /*
         * Metode que revisa les despeses seleccionades d'un full tancat  i retorna un llistat dels seus id
         */
        public static List<Int32> despesesTancadesSeleccionades(ScrollViewer scrollDespeses)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollDespeses.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaDespesesFullTancat vistaDespesa = new VistaDespesesFullTancat();
                vistaDespesa = (VistaDespesesFullTancat)stack.Children[cont];
                if (vistaDespesa.checkDespesa.IsChecked != null && (bool)vistaDespesa.checkDespesa.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaDespesa.blockId.Text));
                }
            }
            return llista;
        }
        #endregion
    }
}
