﻿using ClientSGD.Resources;
using System;
using System.IO;
using System.Threading.Tasks;
using System.Windows;
using Windows.Storage;

namespace ClientSGD.Accions
{
    class Factura
    {
        #region Iniciar apertura de fitxer
        /*
         * Metode asincron que inicia la crida asincrona per obrir un fitxer
         */
        public static async void ObrirAdjunt(string nomAdjunt, byte[] adjunt)
        {
            try
            {
                await WriteToFile(nomAdjunt, adjunt);
            }
            catch
            {
                MessageBox.Show(Missatges.FACTURA_ERROR);
            }
        }
        #endregion

        #region Obrir fitxer
        /*
         * Funcio posterior a la crida asincrona per escriure un fitxer a memoria i obre el fitxer
         */
        private static async Task WriteToFile(string nomAdjunt, byte[] adjunt)
        {
            StorageFolder local = Windows.Storage.ApplicationData.Current.LocalFolder;
            StorageFile file = await local.CreateFileAsync(nomAdjunt, CreationCollisionOption.ReplaceExisting);
            using (FileStream fs = new FileStream(file.Path, FileMode.Truncate, FileAccess.ReadWrite, FileShare.None))
            {
                fs.Write(adjunt, 0, adjunt.Length);
                fs.Flush();
            }
            await Windows.System.Launcher.LaunchFileAsync(file);
        }
        #endregion
    }
}
