﻿using System;
using System.Collections.Generic;
using System.Windows.Controls;

namespace ClientSGD.Accions
{
    class Festiu
    {
        #region Preparar vista de datas festives
        /*
         * Metode que donat un llistat de dates festives, retorna el llistat a un StackPanel
         */
        public static StackPanel llistaGridFestius(List<ServeiWeb.Festiu> llistaFestius)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaFestius.Count; cont++)
            {
                VistaFestiu vista = new VistaFestiu();
                vista.blockData.Text = llistaFestius[cont].Data.ToString("dd/MM/yyyy");
                vista.blockDescripcio.Text = llistaFestius[cont].Descripcio;
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Dates seleccionades
        /*
         * Metode que verifica les dates seleccionades i retorna el llistat dels seus id a un StackPanel
         */
        public static List<DateTime> datesSeleccionades(ScrollViewer scrollDates)
        {
            List<DateTime> llista = new List<DateTime>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollDates.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaFestiu vistaFestiu = new VistaFestiu();
                vistaFestiu = (VistaFestiu)stack.Children[cont];
                if (vistaFestiu.checkFestiu.IsChecked != null && (bool)vistaFestiu.checkFestiu.IsChecked)
                {
                    llista.Add(Convert.ToDateTime(vistaFestiu.blockData.Text));
                }
            }
            return llista;
        }
        #endregion
    }
}
