﻿using System;
using System.Collections.Generic;
using System.Windows.Controls;

namespace ClientSGD.Accions
{
    class FullDespeses
    {
        #region Preparar vista de fulls de despeses tancats
        /*
         * Metode que carrega el llistat de fulls tancats a un StackPanel
         */
        public static StackPanel llistaFullsTancats(List<ServeiWeb.FullDespeses> llistaFulls)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaFulls.Count; cont++)
            {
                VistaFullTancat vistaFull = new VistaFullTancat();
                vistaFull.blockId.Text = llistaFulls[cont].Id.ToString();
                vistaFull.blockObert.Text = "Obert: " + llistaFulls[cont].Obert.ToString();
                vistaFull.blockTotal.Text = "Import total: " + llistaFulls[cont].Total.ToString();
                vistaFull.blockSolicitat.Text = "Sol·licitat: " + llistaFulls[cont].Solicitat.ToString();

                if ((bool)llistaFulls[cont].Estat)
                {
                    vistaFull.blockEstat.Text = "Estat: Acceptat";
                }
                else
                {
                    vistaFull.blockEstat.Text = "Estat: Denegat";
                }
                vistaFull.blockValidat.Text = "Validat: " + llistaFulls[cont].Validat.ToString();
                vistaFull.blockPagat.Text = "Pagat: " + llistaFulls[cont].Pagat.ToString();
                if (llistaFulls[cont].Comentari.Length > 0)
                {
                    vistaFull.blockComentari.Text = "Comentaris: Si";
                }
                else
                {
                    vistaFull.blockComentari.Text = "Comentaris: No";
                }
                stack.Children.Add(vistaFull);
            }
            return stack;
        }
        #endregion

        #region Fulls de despeses tancats seleccionats
        /*
         * Metode que verifica els fulls tancats seleccionats i retorna el llistat dels seus id a un StackPanel
         */
        public static List<Int32> fullsTancatsSeleccionats(ScrollViewer scrollFulls)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = (StackPanel)scrollFulls.Content;
            if (stack != null)
            {
                for (int cont = 0; cont < stack.Children.Count; cont++)
                {
                    VistaFullTancat vistaFull = new VistaFullTancat();
                    vistaFull = (VistaFullTancat)stack.Children[cont];
                    if (vistaFull.checkFull.IsChecked != null && (bool)vistaFull.checkFull.IsChecked)
                    {
                        llista.Add(Convert.ToInt32(vistaFull.blockId.Text));
                    }
                }
            }
            return llista;
        }
        #endregion

        #region Preparar vista de fulls de despeses pendents de validar
        /*
         * Metode que carrega el llistat de fulls pendents de validar a un StackPanel
         */
        public static StackPanel llistaFullsPendents(List<ServeiWeb.FullDespeses> llistaFulls)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaFulls.Count; cont++)
            {
                VistaFullPendent vistaFull = new VistaFullPendent();
                vistaFull.blockId.Text = llistaFulls[cont].Id.ToString();
                vistaFull.blockNom.Text = "Nom treballador: " + llistaFulls[cont].NomUsuari;
                vistaFull.blockCognoms.Text = "Cognoms: " + llistaFulls[cont].CognomsUsuari;
                vistaFull.blockNomCarrec.Text = "Càrrec: " + llistaFulls[cont].NomCarrec;
                vistaFull.blockImportTotal.Text = "Import total: " + llistaFulls[cont].Total.ToString();
                vistaFull.blockObert.Text = "Data apertura: " + llistaFulls[cont].Obert.ToString();
                vistaFull.blockSolicitat.Text = "Sol·licitat: " + llistaFulls[cont].Solicitat.ToString();
                stack.Children.Add(vistaFull);
            }
            return stack;
        }
        #endregion

        #region Fulls de despeses pendents de validar seleccionades
        /*
         * Metode que verifica els fulls pendets de validar seleccionats i retorna el llistat dels seus id a un StackPanel
         */
        public static List<Int32> fullsPendentsSeleccionats(ScrollViewer scrollFulls)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = (StackPanel)scrollFulls.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaFullPendent vistaFull = new VistaFullPendent();
                vistaFull = (VistaFullPendent)stack.Children[cont];
                if (vistaFull.checkFull.IsChecked != null && (bool)vistaFull.checkFull.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaFull.blockId.Text));
                }
            }
            return llista;
        }
        #endregion

        #region Preparar vista de fulls de despeses pendents de pagament
        /*
         * Metode que carrega el llistat de fulls pendents de pagament a un StackPanel
         */
        public static StackPanel llistaFullsPendentsDePagament(List<ServeiWeb.FullDespeses> llistaFulls)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaFulls.Count; cont++)
            {
                VistaPagarDespesa vistaFull = new VistaPagarDespesa();
                vistaFull.blockId.Text = llistaFulls[cont].Id.ToString();
                vistaFull.blockDni.Text = "DNI treballador: " + llistaFulls[cont].DniUsuari;
                vistaFull.blockNom.Text = "Nom: " + llistaFulls[cont].NomUsuari;
                vistaFull.blockCognoms.Text = "Cognoms: " + llistaFulls[cont].CognomsUsuari;
                vistaFull.blockCarrec.Text = "Càrrec: " + llistaFulls[cont].NomCarrec;
                vistaFull.blockData.Text = "Sol·licitat: " + llistaFulls[cont].Solicitat.ToString();
                vistaFull.blockImport.Text = "Import total: " + llistaFulls[cont].Total.ToString();
                stack.Children.Add(vistaFull);
            }
            return stack;
        }
        #endregion

        #region Fulls de despeses pendents de pagament seleccionats
        /*
         * Metode que verifica els fulls pendents de pagament seleccionats i retorna el llistat dels seus id a un StackPanel
         */
        public static List<Int32> fullsPendentsDePagamentSeleccionats(ScrollViewer scrollFulls)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = (StackPanel)scrollFulls.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaPagarDespesa vistaFull = new VistaPagarDespesa();
                vistaFull = (VistaPagarDespesa)stack.Children[cont];
                if (vistaFull.checkDespesa.IsChecked != null && (bool)vistaFull.checkDespesa.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaFull.blockId.Text));
                }
            }
            return llista;
        }
        #endregion
    }
}
