﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;

namespace ClientSGD.Accions
{
    class Permisos
    {
        Int32 id;
        bool administrar, validar;
        bool? veureUsuaris, veureDespeses;
        string nom;

        #region Constructor
        /*
         * Metode constructor
         */
        public Permisos(Int32 id, String nom, bool administrar, bool validar, bool? veureUsuaris, bool? veureDespeses)
        {
            this.id = id;
            this.nom = nom;
            this.administrar = administrar;
            this.validar = validar;
            this.veureUsuaris = veureUsuaris;
            this.veureDespeses = veureDespeses;
        }
        #endregion

        #region Metodes accessoris
        public Int32 Id
        {
            get { return id; }
            set { id = value; }
        }

        public string Nom
        {
            get { return nom; }
            set { nom = value; }
        }

        public bool Administrar
        {
            get { return administrar; }
            set { administrar = value; }
        }

        public bool Validar
        {
            get { return validar; }
            set { validar = value; }
        }

        public bool? VeureUsuaris
        {
            get { return veureUsuaris; }
            set { veureUsuaris = value; }
        }

        public bool? VeureDespeses
        {
            get { return veureDespeses; }
            set { veureDespeses = value; }
        }
        #endregion

        #region Preparar vista de permisos
        /*
         * Llista de permisos
         */
        public static StackPanel llistaGridPermisos(List<ServeiWeb.Permisos> llistaPermisos)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaPermisos.Count; cont++)
            {
                VistaSeleccioPermisos vista = new VistaSeleccioPermisos();
                vista.blockId.Text = llistaPermisos[cont].Id.ToString();
                vista.blockNom.Text = llistaPermisos[cont].Nom;
                if(llistaPermisos[cont].Administrar){
                    vista.checkAdministrar.IsChecked = true;
                }
                if (llistaPermisos[cont].Validar)
                {
                    vista.checkValidar.IsChecked = true;
                }
                if (llistaPermisos[cont].VeureUsuaris!=null && (bool) llistaPermisos[cont].VeureUsuaris)
                {
                    vista.checkVeureUsuaris.IsChecked = true;
                }
                if (llistaPermisos[cont].VeureDespeses != null && (bool)llistaPermisos[cont].VeureDespeses)
                {
                    vista.checkVeureDespeses.IsChecked = true;
                }
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Permisos seleccionats
        /*
         * Permisos seleccionats
         */
        public static List<Int32> permisosSeleccionats(ScrollViewer scrollPermisos)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollPermisos.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaSeleccioPermisos vistaPermisos = new VistaSeleccioPermisos();
                vistaPermisos = (VistaSeleccioPermisos)stack.Children[cont];
                if (vistaPermisos.checkPermis.IsChecked != null && (bool)vistaPermisos.checkPermis.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaPermisos.blockId.Text));
                }
            }
            return llista;
        }
        #endregion
    }
}
