﻿using System;
using System.Collections.Generic;
using System.Windows.Controls;

namespace ClientSGD.Accions
{
    class Tipus
    {
        #region Preparar vista de tipus de despeses actius
        /*
         * Metode que carrega el llistat de tipus de despeses habilitats a un StackPanel
         */
        public static StackPanel llistaGridTipusActivats(List<ServeiWeb.Tipus> llistaTipus)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaTipus.Count; cont++)
            {
                VistaSeleccioTipus vista = new VistaSeleccioTipus();
                vista.blockId.Text = llistaTipus[cont].Id.ToString();
                vista.blockTipus.Text = llistaTipus[cont].Nom;
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Tipus de despeses actius seleccionats
        /*
         * Metode que revisa els tipus de despeses habilitats seleccionats i els retorna en un llistat
         */
        public static List<Int32> tipusActivatsSeleccionats(ScrollViewer scrollTipus)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollTipus.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaSeleccioTipus vistatipus = new VistaSeleccioTipus();
                vistatipus = (VistaSeleccioTipus)stack.Children[cont];
                if (vistatipus.checkTipus.IsChecked != null && (bool)vistatipus.checkTipus.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistatipus.blockId.Text));
                }
            }
            return llista;
        }
        #endregion

        #region Llista de tipus de despeses existents
        /*
         * Metode que carrega el llistat de tipus de despeses existents a un StackPanel
         */
        public static StackPanel llistaGridTipus(List<ServeiWeb.Tipus> llistaTipus)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaTipus.Count; cont++)
            {
                VistaTipus vista = new VistaTipus();
                vista.blockId.Text = llistaTipus[cont].Id.ToString();
                vista.blockTipus.Text = "Nom: " + llistaTipus[cont].Nom;
                string habilitat = "Habilitat: No";
                if (llistaTipus[cont].Habilitat)
                {
                    habilitat = "Habilitat: Si";
                }
                vista.blockHabilitat.Text = habilitat;
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Tipus de despeses existents seleccionats
        /*
         * Metode que revisa els tipus de despeses existents seleccionats i els retorna en un llistat
         */
        public static List<Int32> tipusSeleccionats(ScrollViewer scrollTipus)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollTipus.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaTipus vistatipus = new VistaTipus();
                vistatipus = (VistaTipus)stack.Children[cont];
                if (vistatipus.checkTipus.IsChecked != null && (bool)vistatipus.checkTipus.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistatipus.blockId.Text));
                }
            }
            return llista;
        }
        #endregion
    }
}
