﻿using ClientSGD.Accions;
using System;
using System.Collections.Generic;
using System.Windows.Controls;

namespace ClientSGD.Accions
{
    class Usuari
    {
        private Int32 id, carrec_id, responsable_id;
        private string dni, nom, cognoms;
        private Carrec carrec;

        #region Constructor
        /*
         * Metode constructor
         */
        public Usuari(Int32 id, string dni, string nom, string cognoms, Int32 carrec_id, Int32 responsable_id)
        {
            this.id = id;
            this.dni = dni;
            this.nom = nom;
            this.carrec_id = carrec_id;
            this.cognoms = cognoms;
            this.responsable_id = id;
        }
        #endregion

        #region Metodes accessoris
        public Int32 IdUsuari
        {
            get { return id; }
        }

        public string DniUsuari
        {
            get { return dni; }
        }

        public string NomUsuari
        {
            get { return nom; }
        }

        public string CognomsUsuari
        {
            get { return cognoms; }
        }

        public Int32 CarrecId
        {
            get { return carrec_id; }
        }

        public Carrec Carrec
        {
            get { return carrec; }
            set { this.carrec = value; }
        }
        #endregion

        #region Preparar vista de treballaors de responsable
        /*
         * Metode que carrega el llistat d'usuaris d'una responsable a un StackPanel
         */
        public static StackPanel llistaGridTreballadors(List<ServeiWeb.Usuari> llistaTreballadors)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaTreballadors.Count; cont++)
            {
                VistaTreballador vista = new VistaTreballador();
                vista.blockNom.Text = "Nom: " + llistaTreballadors[cont].Nom;
                vista.blockCognoms.Text = "Cognoms: " + llistaTreballadors[cont].Cognoms;
                vista.blockCarrec.Text = "Càrrec: " + llistaTreballadors[cont].NomCarrec.ToString();
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Preparar vista de usuaris
        /*
         * Metode que carrega el llistat d'usuaris a un StackPanel
         */
        public static StackPanel llistaGridUsuaris(List<ServeiWeb.Usuari> llistaUsuaris)
        {
            StackPanel stack = new StackPanel();
            for (int cont = 0; cont < llistaUsuaris.Count; cont++)
            {
                VistaUsuari vista = new VistaUsuari();
                vista.blockId.Text = llistaUsuaris[cont].Id.ToString();
                vista.blockDni.Text = "DNI: " + llistaUsuaris[cont].Dni;
                vista.blockNom.Text = "Nom: " + llistaUsuaris[cont].Nom;
                vista.blockCognoms.Text = "Cognoms: " + llistaUsuaris[cont].Cognoms;
                vista.blockNomCarrec.Text = "Càrrec: " + llistaUsuaris[cont].NomCarrec.ToString();
                vista.blockDniResponsable.Text = "Responsable: " + llistaUsuaris[cont].DniResponsable.ToString();
                string habilitat = "Habilitat: No";
                if (llistaUsuaris[cont].Habilitat)
                {
                    habilitat = "Habilitat: Si";
                }
                vista.blockHabilitat.Text = habilitat;
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Usuaris existents seleccionats
        /*
         * Metode que revisa els usuaris seleccionats i els retorna en un llistat
         */
        public static List<Int32> usuarisSeleccionats(ScrollViewer scrollUsuaris)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollUsuaris.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaUsuari vistaUsuari = new VistaUsuari();
                vistaUsuari = (VistaUsuari)stack.Children[cont];
                if (vistaUsuari.checkUsuari.IsChecked != null && (bool)vistaUsuari.checkUsuari.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaUsuari.blockId.Text));
                }
            }
            return llista;
        }
        #endregion

        #region Preparar vista de responsables habilitats
        /*
         * Metode que carrega el llistat d'usuaris habilitats a un StackPanel
         */
        public static StackPanel llistaGridResponsables(List<ServeiWeb.Usuari> llistaResponsables)
        {
            StackPanel stack = new StackPanel();
            VistaSeleccioResponsable propiResponsable = new VistaSeleccioResponsable();
            propiResponsable.blockId.Text = "0";
            propiResponsable.blockDNI.Text = "<Propi responsable>";
            propiResponsable.blockNomResponsable.Text = "<Propi responsable>";
            stack.Children.Add(propiResponsable);
            for (int cont = 0; cont < llistaResponsables.Count; cont++)
            {
                VistaSeleccioResponsable vista = new VistaSeleccioResponsable();
                vista.blockId.Text = llistaResponsables[cont].Id.ToString();
                vista.blockDNI.Text = "DNI: " + llistaResponsables[cont].Dni;
                vista.blockNomResponsable.Text = "Nom: " + llistaResponsables[cont].Nom;
                stack.Children.Add(vista);
            }
            return stack;
        }
        #endregion

        #region Responsables habilitats seleccionats
        /*
         * Metode que revisa els responsables seleccionats i els retorna en un llistat
         */
        public static List<Int32> responsablesSeleccionats(ScrollViewer scrollResponsables)
        {
            List<Int32> llista = new List<Int32>();
            StackPanel stack = new StackPanel();
            stack = (StackPanel)scrollResponsables.Content;
            for (int cont = 0; cont < stack.Children.Count; cont++)
            {
                VistaSeleccioResponsable vistaResponsable = (VistaSeleccioResponsable)stack.Children[cont];
                if (vistaResponsable.checkResponsable.IsChecked != null && (bool)vistaResponsable.checkResponsable.IsChecked)
                {
                    llista.Add(Convert.ToInt32(vistaResponsable.blockId.Text));
                }
            }
            return llista;
        }
        #endregion
    }
}
