﻿using System;
using System.Windows;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using ClientSGD.Resources;

namespace ClientSGD
{
    public partial class ComentariDenegarFull : PhoneApplicationPage
    {
        private Int32 fullId;
        private ServeiWeb.ServeiClient servei;

        public ComentariDenegarFull()
        {
            InitializeComponent();
        }

        #region Navegacio
        /*
         * Event que verifica des de on s'arriba a  la pantalla
         */
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            if (e.NavigationMode != NavigationMode.Back)
            {
                fullId = Convert.ToInt32(NavigationContext.QueryString["fullId"]);
            }
        }
        #endregion

        #region Acceptar comentari
        /*
         * Event que verifica que s'ha afegit comentari en denegar un full i inicia la crida asincrona.
         */
        private void clickAcceptarComentari(object sender, RoutedEventArgs e)
        {
            if(textComentari.Text.Length==0){
            }
            else if(textComentari.Text.Length>0){
                servei = ConnexioServei.connexioNova();
                servei.rebutjarPagamentFullCompleted+=serveiRebutjarPagamentFullCompleted;
                servei.rebutjarPagamentFullAsync(fullId,textComentari.Text);
            }
        }
        #endregion

        #region Rebutjar comentari
        /*
         * Funcio posterior a la finalitzacio de la crida asincrona per rebutjar el pagament d'un full de despeses
         */
        private void serveiRebutjarPagamentFullCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            servei.CloseAsync();
            if (e.Error != null)
            {
                MessageBox.Show(Missatges.COMENTARI_AFEGIR_ERROR + Environment.NewLine + Missatges.REPETIR);
            }
            else
            {
                NavigationService.GoBack();
            }
        }
        #endregion

        #region Tornar
        /*
         * Event que retorna a la pantalla del llistat de fulls pendents en no acceptar afegir comentari per rebutjar un full
         */
        private void clickDenegarComentari(object sender, RoutedEventArgs e)
        {
            NavigationService.GoBack();
        }
        #endregion
    }
}