﻿using ClientSGDEscriptori.Resources;
using System;
using System.Windows.Forms;

namespace ClientSGDEscriptori.Accions
{
    class Factura
    {
        #region Buscar nom de factura adjunta
        /*
         * Metode que retornar el nom d'una factura,donat el id de la despesa
         */
        public static string buscarNomFactura(Int32 despesaId)
        {
            using (ServeiWeb.ServeiClient servei = ConnexioServei.nouServei())
            {
                try
                {
                    string nom = servei.buscarNomDeFactura(despesaId);
                    return nom;
                }
                catch
                {
                    MessageBox.Show(Missatges.CONSULTA_TORNAR);
                    return string.Empty;
                }
            }
        }
        #endregion

        #region Buscar id de factura adjunta
        /*
         * Metode que retorna el id d'una factura,donat el id de la despesa
         */
        public static Int32 buscarIdFactura(Int32 despesaId)
        {
            using (ServeiWeb.ServeiClient servei = ConnexioServei.nouServei())
            {
                try
                {
                    Int32 idFactura = servei.buscarIdFactura(despesaId);
                    return idFactura;
                }
                catch
                {
                    MessageBox.Show(Missatges.CONSULTA_TORNAR);
                    return 0;
                }
            }
        }
        #endregion

        #region Buscar factura adjunta
        /*
         * Metode que retorna l'adjunt d'una factura,donat el id de la despesa
         */
        public static byte[] buscarFacturaAdjunta(Int32 despesaId)
        {
            using (ServeiWeb.ServeiClient servei = ConnexioServei.nouServei())
            {
                try
                {
                    return servei.buscarAdjuntDeDespesa(despesaId);
                }
                catch
                {
                    MessageBox.Show(Missatges.CONSULTA_TORNAR);
                    return null;
                }
            }
        }
        #endregion
    }
}
