﻿using ClientSGDEscriptori.Resources;
using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace ClientSGDEscriptori.Accions
{
    class Permisos
    {
        Int32 id;
        bool administrar, validar;
        bool? veureUsuaris, veureDespeses;
        string nom;

        #region Constructor
        /*
         * Metode constructor
         */
        public Permisos(Int32 id, String nom, bool administrar, bool validar, bool? veureUsuaris, bool? veureDespeses)
        {
            this.id = id;
            this.nom = nom;
            this.administrar = administrar;
            this.validar = validar;
            this.veureUsuaris = veureUsuaris;
            this.veureDespeses = veureDespeses;
        }
        #endregion

        #region Metodes accessoris
        public Int32 Id
        {
            get { return id; }
            set { id = value; }
        }

        public string Nom
        {
            get { return nom; }
            set { nom = value; }
        }

        public bool Administrar
        {
            get { return administrar; }
            set { administrar = value; }
        }

        public bool Validar
        {
            get { return validar; }
            set { validar = value; }
        }

        public bool? VeureUsuaris
        {
            get { return veureUsuaris; }
            set { veureUsuaris = value; }
        }

        public bool? VeureDespeses
        {
            get { return veureDespeses; }
            set { veureDespeses = value; }
        }
        #endregion

        #region Buscar permisos per id
        /*
         * Metode per buscar un permis,donat el seu id
         */
        public static Permisos buscarPermisosPerId(Int32 permisosId)
        {
            
            using (ServeiWeb.ServeiClient servei = ConnexioServei.nouServei())
            {
                try
                {
                    ServeiWeb.Permisos permisosServei = servei.buscarPermisosPerId(permisosId);
                    if (permisosServei != null)
                    {
                        Permisos permis = new Permisos(permisosServei.Id, permisosServei.Nom, permisosServei.Administrar, permisosServei.Validar, permisosServei.VeureUsuaris, permisosServei.VeureDespeses);
                        return permis;
                    }
                    return null;
                }
                catch
                {
                    MessageBox.Show(Missatges.CONSULTA_ERROR);
                    return null;
                }
            }
        }
        #endregion

        #region Buscar permisos pel nom
        /*
         * Metode per buscar un permis pel seu nom
         */
        public static ServeiWeb.Permisos buscarPermisPerNom(string nomPermis)
        {
            using (ServeiWeb.ServeiClient servei = ConnexioServei.nouServei())
            {
                try
                {
                    return servei.buscarPermisPelNom(nomPermis);
                }
                catch
                {
                    MessageBox.Show(Missatges.CONSULTA_ERROR);
                    return null;
                }
            }
        }
        #endregion

        #region Llista de permisos
        /*
         * Metode que retorna el llistat de permisos existents
         */
        public static List<ServeiWeb.Permisos> llistaPermisos()
        {
            using (ServeiWeb.ServeiClient servei = ConnexioServei.nouServei())
            {
                try
                {
                    return servei.llistarPermisos();
                }
                catch
                {
                    MessageBox.Show(Missatges.LLISTAT_ERROR);
                    return null;
                }
            }
        }
        #endregion
    }
}
