﻿using ClientSGDEscriptori.Accions;
using ClientSGDEscriptori.Resources;
using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace ClientSGDEscriptori.Administrar
{
    public partial class AdministracioCarrec : Form
    {
        private Int32 carrecId;
        public ServeiWeb.Carrec carrecAfegit { get; set; }

        public AdministracioCarrec(Int32 carrecId)
        {
            InitializeComponent();
            this.carrecId = carrecId;
        }

        #region Inici formulari
        /*
         * Event inicial del formulari
         */
        private void AdministrarCarrecCarregat(object sender, EventArgs e)
        {
            List<ServeiWeb.Permisos> llistaPermisos = Permisos.llistaPermisos();
            for (int cont = 0; cont < llistaPermisos.Count; cont++)
            {
                comboPermisos.Items.Add(llistaPermisos[cont].Nom);
            }
            comboPermisos.Items.Add("<<Sense Permisos>>");
            //Afegir nou carrec
            if (carrecId == 0)
            {
                comboPermisos.Text = "<<Sense Permisos>>";
            }
            //Modificar carrec existent
            else if (carrecId > 0)
            {
                //Si existeixen permisos es mostren
                Carrec carrec = Carrec.buscarCarrecPerId(carrecId);
                textNom.Text = carrec.CarrecNom;
                if (carrec.PermisosId == 0)
                {
                    comboPermisos.Text = "<<Sense Permisos>>";
                }
                else
                {
                    comboPermisos.Text = Permisos.buscarPermisosPerId((Int32)carrec.PermisosId).Nom;
                }
            }
        }
        #endregion

        #region Guardar carrec
        /*
         * Event per guardar el carrec depenent de si es nou o es modifica un existent
         */
        private void clickGuardar(object sender, EventArgs e)
        {
            if (textNom.Text.Length > 0)
            {
                int? permisos;
                if (comboPermisos.Text.Equals("<<Sense Permisos>>"))
                {
                    permisos = 0;
                }
                else
                {
                    permisos = Permisos.buscarPermisPerNom(comboPermisos.Text).Id;
                }
                #region Carrec nou
                if (carrecId == 0)
                {
                    //Si es un carrec nou, guardem a la variable estatica el nou carrec
                    carrecAfegit = Carrec.afegirCarrec(textNom.Text, permisos);
                    if (carrecAfegit != null)
                    {
                        DialogResult = DialogResult.OK;
                    }
                }
                #endregion
                #region Carrec existent
                else if (carrecId > 0)
                {
                    if (Carrec.modificarCarrec(carrecId, textNom.Text, permisos))
                    {
                        DialogResult = DialogResult.OK;
                    }
                }
                #endregion
            }
            else
            {
                MessageBox.Show(Missatges.DADES_INCOMPLETES);
            }
        }
        #endregion

        #region Tornar
        /*
         * Event per tornar a la pantalla principal d'administració
         */
        private void clickCancelar(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }
        #endregion
    }
}
