﻿using ClientSGDEscriptori.Accions;
using ClientSGDEscriptori.Resources;
using System;
using System.Windows.Forms;

namespace ClientSGDEscriptori.Administrar
{
    public partial class AdministracioTipus : Form
    {
        private Int32 tipusId;
        public ServeiWeb.Tipus tipusAfegit { get; set; }

        public AdministracioTipus(Int32 tipusId)
        {
            InitializeComponent();
            this.tipusId = tipusId;
        }

        #region Inici formulari
        /*
         * Event inicial del formulari
         */
        private void AdministrarTipusCarregat(object sender, EventArgs e)
        {
            //Tipus nou
            if (tipusId == 0)
            {

            }
            //Tipus existent
            else
            {
                ServeiWeb.Tipus tipus = Tipus.buscarTipusPerId(tipusId);
                if (tipus != null)
                {
                    textNom.Text = tipus.Nom;
                }
            }
        }
        #endregion

        #region Guardar tipus
        /*
         * Event per guardar un tipus nou o modificar un existent 
         */
        private void clickGuardar(object sender, EventArgs e)
        {
            if (textNom.Text.Length > 0)
            {
                //Si es un tipus nou, es guarda a la variable estatica el nou tipus
                if (tipusId == 0)
                {
                    tipusAfegit = Tipus.afegirTipus(textNom.Text);
                    if (tipusAfegit != null)
                    {
                        DialogResult = DialogResult.OK;
                    }
                }
                //Modificar tipus existent
                else if (tipusId > 0)
                {
                    if (Tipus.modificarTipus(tipusId, textNom.Text))
                    {
                        DialogResult = DialogResult.OK;
                    }
                }
            }
            else
            {
                MessageBox.Show(Missatges.DADES_INCOMPLETES);
            }
        }
        #endregion

        #region Tornar
        /*
         * Event per tornar a la pantalla principal d'administració
         */
        private void clickCancelar(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }
        #endregion
    }
}
