﻿using ClientSGDEscriptori.Resources;
using System;
using System.Configuration;
using System.Drawing;
using System.Windows.Forms;

namespace ClientSGDEscriptori
{
    public partial class ConfiguracioServei : Form
    {
        public ConfiguracioServei()
        {
            InitializeComponent();
        }

        #region Inici formulari
        /*
         * Event inicial del formulari
         */
        private void configuracioCarregat(object sender, EventArgs e)
        {
            textIp.Text = ConfigurationManager.AppSettings["IpServei"];
            textUrl.Text = ConfigurationManager.AppSettings["PublicacioServei"];
        }
        #endregion

        #region Verificar connexió de servei web
        /*
         * Event per verificar la connexio amb el servei web
         */
        private void clickVerificarConnexio(object sender, EventArgs e)
        {
            botoVerificar.Enabled = false;
            botoGuardar.Enabled = false;
            comprobarDades();
        }
        #endregion

        #region Verificar dades de configuracio del servei web
        /*
         * Metode per mostrar informacio depenent de la connexio amb el servei web
         */
        private void comprobarDades()
        {
            if (!ConnexioServei.verificarConnexioServeiWeb())
            {
                labelResultat.BackColor = Color.Red;
                labelResultat.Text = Missatges.CONNEXIO_SERVEI_OK;
            }
            else
            {
                labelResultat.BackColor = Color.Green;
                labelResultat.Text = Missatges.CONNEXIO_SERVEI_KO;
            }
            botoVerificar.Enabled = true;
            botoGuardar.Enabled = true;
        }
        #endregion

        #region Guardar configuracio
        /*
         * Event per verificar les dades de connexio i guardar-les a l'arxiu de configuracio 
         */
        private void clickGuardarConfiguracio(object sender, EventArgs e)
        {
            if (textIp.Text.Length > 0 && textUrl.Text.Length > 0)
            {
                if (ConnexioServei.verificarIp(textIp.Text))
                {
                    botoVerificar.Enabled = false;
                    botoGuardar.Enabled = false;
                    ConnexioServei.canviarDadesServei(textIp.Text, textUrl.Text);
                    comprobarDades();
                }
                else
                {
                    MessageBox.Show(Missatges.IP_INVALIDA);
                }
            }
            else
            {
                MessageBox.Show(Missatges.DADES_INCOMPLETES);
            }
        }
        #endregion

        #region Tornar
        /*
         * Event per tornar al menú principal
         */
        private void clickTornar(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }
        #endregion
    }
}
