﻿using ClientSGDEscriptori.Accions;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;

namespace ClientSGDEscriptori.GestioDespeses
{
    public partial class GestioDespesesTancades : Form
    {
        private Int32 fullId;

        public GestioDespesesTancades(Int32 fullId)
        {
            InitializeComponent();
            this.fullId = fullId;
        }

        #region Inici formulari
        /*
         * Event inicial del formulari
         */
        private void despesesTancadesCarregat(object sender, EventArgs e)
        {
            carregarDespeses();
        }
        #endregion

        #region Carregar despeses
        /*
         * Metode que carrega el llistat de despeses, donat el id del full de despeses
         */
        private void carregarDespeses()
        {
            List<ServeiWeb.Despesa> llistaDespeses = Despesa.despesesDeFull(fullId);
            if(llistaDespeses!=null && llistaDespeses.Count>0){
                for (int cont = 0; cont < llistaDespeses.Count;cont++ )
                {
                    string acceptada = "No";
                    if(llistaDespeses[cont].Acceptada==null ||llistaDespeses[cont].Acceptada==true){
                        acceptada = "Si";
                    }
                    string comentari = "Sense";
                    if(llistaDespeses[cont].Comentari.Length>0){
                        comentari = "Veure";
                    }
                    string adjunt = "Sense";
                    if(llistaDespeses[cont].Adjunt){
                        adjunt = "Obrir";
                    }
                    string[] linia = new string[] { llistaDespeses[cont].Id.ToString(), llistaDespeses[cont].Data.ToString("dd/MM/yyyy"), llistaDespeses[cont].Import.ToString(), llistaDespeses[cont].NomTipus, acceptada, comentari, adjunt };
                    gridDespesesTancades.Rows.Add(linia);
                }
            }
        }
        #endregion

        #region Cel·la seleccionada
        /*
         * Event per verificar fila i columna seleccionada
         */
        private void clickCela(object sender, DataGridViewCellEventArgs e)
        {
           if(e.RowIndex>=0){
                //Si es la columna de comentaris i hi ha comentari, s'obre el formulari per mostrar comentaris
                if (e.ColumnIndex == 5 && gridDespesesTancades.Rows[e.RowIndex].Cells["columnaComentari"].Value.Equals("Veure"))
                {
                    using (VisioComentari comentari = new VisioComentari("Comentari:", Despesa.comentarisDespesa(Convert.ToInt32(gridDespesesTancades.Rows[e.RowIndex].Cells["columnaId"].Value))))
                    {
                        comentari.ShowDialog();
                    }
                }
                //Si es la columna d'adjunts i hi ha adjunt, es descarrega l'adjunt i s'obre
                if (e.ColumnIndex == 6 && gridDespesesTancades.Rows[e.RowIndex].Cells["columnaAdjunt"].Value.Equals("Obrir"))
                {
                    //Es guarda l'adjunt a un array de bytes
                    byte[] adjunt = Factura.buscarFacturaAdjunta(Convert.ToInt32(gridDespesesTancades.Rows[e.RowIndex].Cells["columnaId"].Value));
                    if (adjunt != null)
                    {
                        string nomFactura = Factura.buscarNomFactura(Convert.ToInt32(gridDespesesTancades.Rows[e.RowIndex].Cells["columnaId"].Value));
                        //Es crea l'adjunt a la ruta dels arxius temporals
                        File.WriteAllBytes(Path.GetTempPath() + "\\" + nomFactura, adjunt);
                        //S'inicia un nou proces per visualitzar l'adjunt
                        Process.Start(Path.GetTempPath() + "\\" + nomFactura);
                    }
                }
            }

        }
        #endregion

        #region Tornar
        /*
         * Event per tornar al formulari anterior
         */
        private void clickTornar(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }
        #endregion
    }
}
