﻿using ClientSGDEscriptori.Accions;
using ClientSGDEscriptori.Resources;
using System;
using System.Windows.Forms;

namespace ClientSGDEscriptori
{
    public partial class LoginMenu : Form
    {
        private int max = 0;
        public string usuari { get; set; }

        public LoginMenu()
        {
            InitializeComponent();
        }

        #region Acceptar usuari i contrasenya
        /*
         * Event per autentificar un usuari del sistema i permetre continuar executant l'aplicacio
         */
        private void clickAcceptar(object sender, EventArgs e)
        {
            //Es necessari indicar usuari i contrasenya
            if (textUsuari.Text.Length == 0 || textContrasenya.Text.Length == 0)
            {
                MessageBox.Show(Missatges.LOGIN_NECESSARI);
            }
            else
            {
                //Si les dades son incorrectes
                if (!Usuari.esValid(textUsuari.Text, textContrasenya.Text))
                {
                    MessageBox.Show(Missatges.LOGIN_INCORRECTE);
                    //Es permeten 3 intents o es tanca l' aplicació
                    if (max == 2)
                    {
                        DialogResult = DialogResult.Cancel;
                    }
                    //S'incrementa la variable d'intents realitzats
                    max++;
                }
                //Si l'usuari es correcte, s'indica el seu DNI (usuari del sistema) i es retorna al formulari principal
                else
                {
                    usuari = textUsuari.Text;
                    DialogResult = DialogResult.OK;
                }
            }
        }
        #endregion

        #region Cancel·lar login
        //Si l'usuari cancel·la l'autentificació al sistema es tancara
        private void clickCancelar(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }
        #endregion
    }
}
