﻿using ClientSGDEscriptori.Accions;
using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace ClientSGDEscriptori
{
    public partial class PagarDespeses : Form
    {
        public PagarDespeses()
        {
            InitializeComponent();
        }

        #region Inici formulari
        /*
         * Event inicial del formulari
         */
        private void pagarDespesesCarregat(object sender, EventArgs e)
        {
            llistarFulls();
        }
        #endregion

        #region Llista de fulls
        /*
         * Metode per carregar el llistat de fulls pendents de pagament
         */
        private void llistarFulls()
        {
            List<ServeiWeb.FullDespeses> llistaFulls = FullDespeses.llistaFullsPendentsPagament();
            gridFullsPendents.Rows.Clear();
            if (llistaFulls != null && llistaFulls.Count > 0)
            {
                for (int cont = 0; cont < llistaFulls.Count; cont++)
                {
                    string[] linia = new string[] { llistaFulls[cont].Id.ToString(), null, llistaFulls[cont].DniUsuari, llistaFulls[cont].NomUsuari, llistaFulls[cont].CognomsUsuari, llistaFulls[cont].NomCarrec, llistaFulls[cont].Solicitat.ToString(), llistaFulls[cont].Total.ToString() };
                    gridFullsPendents.Rows.Add(linia);
                }
            }
        }
        #endregion

        #region Fulls seleccionats
        /*
         * Metode que retornar un llistat amb els id dels fulls seleccionats
         */
        private List<Int32> fullsSeleccionats()
        {
            List<Int32> files = new List<Int32>();
            for (int cont = 0; cont < gridFullsPendents.Rows.Count; cont++)
            {
                if ((bool)gridFullsPendents.Rows[cont].Cells["columnaCheck"].FormattedValue)
                {
                    Int32 fila = Convert.ToInt32(gridFullsPendents.Rows[cont].Cells[0].Value);
                    files.Add(fila);
                }
            }
            return files;
        }
        #endregion

        #region Pagar fulls seleccionats
        /*
         * Event per pagar els fulls seleccionats
         */
        private void clickPagarSeleccionades(object sender, EventArgs e)
        {
            List<Int32> llista = fullsSeleccionats();
            if (llista.Count == 0)
            {
                //No fer res
            }
            else if (llista.Count > 0)
            {
                if (FullDespeses.pagarFullsPendents(llista))
                {
                    llistarFulls();
                }
            }
        }
        #endregion

        #region Tornar
        /*
         * Event per tornar al menu principal
         */
        private void clickTornar(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }
        #endregion
    }
}
