﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace ServeiSGD
{
    [ServiceContract]
    public interface IServei
    {
        #region Despeses
        //Despeses
        [OperationContract]
        bool verificarAdjunt(Int32 idDespesa);

        [OperationContract]
        void esborrarDespeses(List<Int32> id, List<bool> despesesAdjunt);

        [OperationContract]
        Despesa afegirNovaDespesa(Int32 fullId, DateTime data, decimal import, Int32 tipusId, string comentari, string nomArxiu, byte[] adjunt);

        [OperationContract]
        List<Despesa> llistaDespesesDefull(Int32 fullId);

        [OperationContract]
        void denegarDespeses(List<Int32> despeses);

        [OperationContract]
        void acceptarDespeses(List<Int32> despeses);

        [OperationContract]
        Despesa buscarDespesa(Int32 despesaId);

        [OperationContract]
        void modificarDespesa(Int32 despesaId, DateTime data, decimal import, Int32 tipusId, string comentari, Int32 facturaId, string nomFactura, byte[] adjunt);

        [OperationContract]
        string buscarComentariDeDespesa(Int32 despesaId);
        #endregion

        #region Tipus de despeses
        //Tipus
        [OperationContract]
        Tipus buscarTipusPerNom(string nom);

        [OperationContract]
        Tipus buscarTipusPerId(Int32 tipusId);

        [OperationContract]
        Tipus afegirTipusNou(string nom);

        [OperationContract]
        void modificarTipus(Int32 id, string nom);

        [OperationContract]
        bool tipusHabilitat(Int32 id);

        [OperationContract]
        void habilitarTipus(Int32 id);

        [OperationContract]
        void deshabilitarTipus(Int32 id);

        [OperationContract]
        List<Tipus> llistarTipusActius();

        [OperationContract]
        List<Tipus> llistarTipus();
        #endregion 

        #region Fulls de despeses
        //Full despeses
        [OperationContract]
        DateTime solicitarPagamentFullDespeses(Int32 fullId);

        [OperationContract]
        List<FullDespeses> buscarFullsPendentsDeResponsable(Int32 responsableId);

        [OperationContract]
        List<FullDespeses> llistarFullsPendentsPagar();

        [OperationContract]
        void pagarFullsDespesesPendents(List<Int32> llistaFulls);

        [OperationContract]
        FullDespeses buscarFullObert(Int32 usuariId);

        [OperationContract]
        FullDespeses obrirFullNou(Int32 usuariId);

        [OperationContract]
        void rebutjarPagamentFull(Int32 idFull, string comentari);

        [OperationContract]
        void acceptarPagamentFull(Int32 idFull);

        [OperationContract]
        List<FullDespeses> llistaFullsTancats(Int32 usuariId);

        [OperationContract]
        string comentariDeFull(Int32 fullId);
        #endregion 

        #region Factures
        //Factures
        [OperationContract]
        string buscarNomDeFactura(Int32 despesaId);

        [OperationContract]
        Int32 buscarIdFactura(Int32 despesaId);

        [OperationContract]
        byte[] buscarAdjuntDeDespesa(Int32 despesaId);
        #endregion

        #region Usuaris
        //Usuaris
        [OperationContract]
        bool validarUsuari(string usuari, string contrasenya);

        [OperationContract]
        bool existeixUsuariPerDNI(string dni);

        [OperationContract]
        Usuari afegirNouUsuari(string dni, string nom, string cognoms, Int32 carrecId, Int32 responsableId, string contrasenya);

        [OperationContract]
        List<Usuari> llistaDeUsuarisActius();

        [OperationContract]
        void activarUsuari(Int32 usuariId);

        [OperationContract]
        void desactivarUsuari(Int32 usuariId);

        [OperationContract]
        bool usuariHabilitat(Int32 usuariId);

        [OperationContract]
        void modificarUsuariExistent(Int32 id, string dni, string nom, string cognoms, Int32 carrecId, Int32 responsableId, string contrasenya);

        [OperationContract]
        List<Usuari> dniAmb(string paraula);
        [OperationContract]

        Usuari buscarUsuariPerDni(string dniUsuari);

        [OperationContract]
        List<Usuari> usuarisDeResponsable(Int32 responsableId);

        [OperationContract]
        List<Usuari> llistarUsuaris();

        [OperationContract]
        Usuari buscarUsuariPerId(Int32 id);

        [OperationContract]
        List<Usuari> nomsUsuariAmb(string paraula);

        [OperationContract]
        List<Usuari> cognomsUsuariAmb(string paraula);

        [OperationContract]
        List<Usuari> nomIcognomsAmb(string paraulaNom, string paraulaCognoms);
        #endregion

        #region Carrecs
        //Carrecs
        [OperationContract]
        Carrec buscarCarrecPerId(Int32 carrec_id);

        [OperationContract]
        Carrec buscarCarrecPerNom(string nomCarrec);

        [OperationContract]
        bool verificarEstatCarrec(Int32 carrecId);

        [OperationContract]
        void habilitarCarrec(Int32 carrecId);

        [OperationContract]
        void deshabilitarCarrec(Int32 carrecId);

        [OperationContract]
        Carrec afegirCarrec(string nom, int? permisos);

        [OperationContract]
        void modificarCarrecExistent(Int32 id, string nom, int? permisos);

        [OperationContract]
        List<Carrec> llistarCarrecs();

        [OperationContract]
        List<Carrec> llistarCarrecsActius();
        #endregion

        #region Permisos
        //Permisos
        [OperationContract]
        Permisos buscarPermisosPerId(Int32 permisos_id);

        [OperationContract]
        Permisos buscarPermisPelNom(string permisNom);

        [OperationContract]
        List<Permisos> llistarPermisos();
        #endregion

        #region Festius
        //Festius
        [OperationContract]
        List<Festiu> llistarFestius();

        [OperationContract]
        List<DateTime> llistarDatesFestives();

        [OperationContract]
        Festiu afegirFestiuNou(DateTime data, string descripcio);

        [OperationContract]
        void eliminarFestiu(DateTime data);

        [OperationContract]
        bool verificarDiaFestiu(DateTime data);
        #endregion
    }

    [DataContract]
    public class Usuari
    {
        #region Usuari
        Int32 id, idCarrec, idResponsable;
        string dni, nom, cognoms, contrasenya, nomCarrec, dniResponsable;
        bool habilitat;
        DateTime actualitzacio;

        [DataMember]
        public Int32 Id
        {
            get { return id; }
            set { id = value; }
        }

        [DataMember]
        public string Dni
        {
            get { return dni; }
            set { dni = value; }
        }

        [DataMember]
        public string Nom
        {
            get { return nom; }
            set { nom = value; }
        }

        [DataMember]
        public string Cognoms
        {
            get { return cognoms; }
            set { cognoms = value; }
        }

        [DataMember]
        public Int32 IdCarrec
        {
            get { return idCarrec; }
            set { idCarrec = value; }
        }

        [DataMember]
        public string NomCarrec
        {
            get { return nomCarrec; }
            set { nomCarrec = value; }
        }

        [DataMember]
        public string DniResponsable
        {
            get { return dniResponsable; }
            set { dniResponsable = value; }
        }

        [DataMember]
        public Int32 IdResponsable
        {
            get { return idResponsable; }
            set { idResponsable = value; }
        }

        [DataMember]
        public string Contrasenya
        {
            get { return contrasenya; }
            set { contrasenya = value; }
        }

        [DataMember]
        public bool Habilitat
        {
            get { return habilitat; }
            set { habilitat = value; }
        }

        [DataMember]
        public DateTime Actualitzacio
        {
            get { return actualitzacio; }
            set { actualitzacio = value; }
        }
        #endregion
    }

    [DataContract]
    public class Carrec
    {
        #region Carrec
        Int32 id, idPermisos;
        string nom, nomPermisos;
        bool habilitat;
        DateTime actualitzacio;

        [DataMember]
        public Int32 Id
        {
            get { return id; }
            set { id = value; }
        }

        [DataMember]
        public string Nom
        {
            get { return nom; }
            set { nom = value; }
        }

        [DataMember]
        public Int32? IdPermisos
        {
            get { return idPermisos; }
            set { idPermisos = value.Value; }
        }

        [DataMember]
        public string NomPermisos
        {
            get { return nomPermisos; }
            set { nomPermisos = value; }
        }

        [DataMember]
        public bool Habilitat
        {
            get { return habilitat; }
            set { habilitat = value; }
        }

        [DataMember]
        public DateTime Actualitzacio
        {
            get { return actualitzacio; }
            set { actualitzacio = value; }
        }
        #endregion
    }


    [DataContract]
    public class Permisos
    {
        #region Permisos
        Int32 id;
        string nom;
        bool validar, administrar;
        bool? veureUsuaris, veureDespeses;

        [DataMember]
        public Int32 Id
        {
            get { return id; }
            set { id = value; }
        }

        [DataMember]
        public string Nom
        {
            get { return nom; }
            set { nom = value; }
        }

        [DataMember]
        public bool Validar
        {
            get { return validar; }
            set { validar = value; }
        }

        [DataMember]
        public bool Administrar
        {
            get { return administrar; }
            set { administrar = value; }
        }
        [DataMember]
        public bool? VeureDespeses
        {
            get { return veureDespeses; }
            set { veureDespeses = value; }
        }

        [DataMember]
        public bool? VeureUsuaris
        {
            get { return veureUsuaris; }
            set { veureUsuaris = value; }
        }
        #endregion
    }

    [DataContract]
    public class FullDespeses
    {
        #region Full despeses
        Int32 id, usuari_id;
        decimal total;
        bool? estat;
        DateTime obert, actualitzacio;
        string dniUsuari, nomUsuari, cognomsUsuari, nomCarrec, comentari;
        DateTime? solicitat, validat, pagat;

        [DataMember]
        public Int32 Id
        {
            get { return id; }
            set { id = value; }
        }

        [DataMember]
        public Int32 Usuari_Id
        {
            get { return usuari_id; }
            set { usuari_id = value; }
        }

        [DataMember]
        public string DniUsuari
        {
            get { return dniUsuari; }
            set { dniUsuari = value; }
        }

        [DataMember]
        public string NomUsuari
        {
            get { return nomUsuari; }
            set { nomUsuari = value; }
        }

        [DataMember]
        public string CognomsUsuari
        {
            get { return cognomsUsuari; }
            set { cognomsUsuari = value; }
        }

        [DataMember]
        public string NomCarrec
        {
            get { return nomCarrec; }
            set { nomCarrec = value; }
        }

        [DataMember]
        public DateTime Obert
        {
            get { return obert; }
            set { obert = value; }
        }

        [DataMember]
        public decimal Total
        {
            get { return total; }
            set { total = value; }
        }

        [DataMember]
        public DateTime? Solicitat
        {
            get { return solicitat; }
            set { solicitat = value; }
        }

        [DataMember]
        public bool? Estat
        {
            get { return estat; }
            set { estat = value; }
        }

        [DataMember]
        public DateTime? Validat
        {
            get { return validat; }
            set { validat = value; }
        }

        [DataMember]
        public DateTime? Pagat
        {
            get { return pagat; }
            set { pagat = value; }
        }

        [DataMember]
        public string Comentari
        {
            get { return comentari; }
            set { comentari = value; }
        }

        [DataMember]
        public DateTime Actualitzacio
        {
            get { return actualitzacio; }
            set { actualitzacio = value; }
        }
        #endregion
    }

    [DataContract]
    public class Tipus
    {
        #region Tipus
        Int32 id;
        string nom;
        bool habilitat;
        DateTime actualitzacio;

        [DataMember]
        public Int32 Id
        {
            get { return id; }
            set { id = value; }
        }

        [DataMember]
        public string Nom
        {
            get { return nom; }
            set { nom = value; }
        }

        [DataMember]
        public bool Habilitat
        {
            get { return habilitat; }
            set { habilitat = value; }
        }

        [DataMember]
        public DateTime Actualitzacio
        {
            get { return actualitzacio; }
            set { actualitzacio = value; }
        }
        #endregion
    }

    [DataContract]
    public class Despesa
    {
        #region Despesa
        Int32 id, full_despesa, tipus;
        decimal import;
        bool? acceptada;
        string nomTipus, comentari;
        bool adjunt;
        DateTime data, actualitzacio;

        [DataMember]
        public Int32 Id
        {
            get { return id; }
            set { id = value; }
        }

        [DataMember]
        public Int32 Full_despesa
        {
            get { return full_despesa; }
            set { full_despesa = value; }
        }

        [DataMember]
        public DateTime Data
        {
            get { return data; }
            set { data = value; }
        }

        [DataMember]
        public decimal Import
        {
            get { return import; }
            set { import = value; }
        }

        [DataMember]
        public Int32 Tipus
        {
            get { return tipus; }
            set { tipus = value; }
        }

        [DataMember]
        public string NomTipus
        {
            get { return nomTipus; }
            set { nomTipus = value; }
        }

        [DataMember]
        public bool? Acceptada
        {
            get { return acceptada; }
            set { acceptada = value; }
        }

        [DataMember]
        public string Comentari
        {
            get { return comentari; }
            set { comentari = value; }
        }

        [DataMember]
        public bool Adjunt
        {
            get { return adjunt; }
            set { adjunt = value; }
        }

        [DataMember]
        public DateTime Actualitzacio
        {
            get { return actualitzacio; }
            set { actualitzacio = value; }
        }
        #endregion
    }

    [DataContract]
    public class Festiu
    {
        #region Festiu
        DateTime data, actualitzacio;
        string descripcio;

        [DataMember]
        public DateTime Data
        {
            get { return data; }
            set { data = value; }
        }

        [DataMember]
        public string Descripcio
        {
            get { return descripcio; }
            set { descripcio = value; }
        }

        [DataMember]
        public DateTime Actualitzacio
        {
            get { return actualitzacio; }
            set { actualitzacio = value; }
        }
        #endregion
    }
}
