﻿using ServeiSGD.Accions;
using System;
using System.Collections.Generic;

namespace ServeiSGD
{
    public class Servei : IServei
    {
        #region Permisos
        //Permisos
        public Permisos buscarPermisosPerId(Int32 permisos_id)
        { return PermisosAccions.buscarPermisosPerId(permisos_id); }

        public Permisos buscarPermisPelNom(string permisNom)
        { return PermisosAccions.buscarPermisPerNom(permisNom); }

        public List<Permisos> llistarPermisos()
        { return PermisosAccions.LlistaDePermisos(); }
        #endregion

        #region Carrecs
        //Carrecs
        public Carrec buscarCarrecPerId(int carrec_id)
        { return CarrecAccions.buscarCarrecPerId(carrec_id); }

        public Carrec buscarCarrecPerNom(string nomCarrec)
        { return CarrecAccions.buscarCarrecPerNom(nomCarrec); }

        public List<Carrec> llistarCarrecs()
        { return CarrecAccions.llistaDeCarrecs(); }

        public List<Carrec> llistarCarrecsActius()
        { return CarrecAccions.llistaCarrecsDisponibles(); }

        public Carrec afegirCarrec(string nom, int? permisos)
        { return CarrecAccions.afegirCarrecNou(nom, permisos); }

        public void modificarCarrecExistent(Int32 id, string nom, int? permisos)
        { CarrecAccions.modificarCarrec(id, nom, permisos); }

        public bool verificarEstatCarrec(Int32 carrecId)
        { return CarrecAccions.verificarEstatCarrec(carrecId); }

        public void habilitarCarrec(Int32 carrecId)
        { CarrecAccions.habilitarCarrec(carrecId); }

        public void deshabilitarCarrec(Int32 carrecId)
        { CarrecAccions.deshabilitarCarrec(carrecId); }
        #endregion

        #region Usuaris
        //Usuaris
        public bool validarUsuari(string usuari, string contrasenya)
        { return UsuariAccions.validacioUsuari(usuari, contrasenya); }

        public List<Usuari> llistaDeUsuarisActius()
        { return UsuariAccions.llistaDeUsuarisDisponibles(); }

        public Usuari afegirNouUsuari(string dni, string nom, string cognoms, Int32 carrecId, Int32 responsableId, string contrasenya)
        { return UsuariAccions.afegirUsuari(dni, nom, cognoms, carrecId, responsableId, contrasenya); }

        public void modificarUsuariExistent(Int32 id, string dni, string nom, string cognoms, Int32 carrecId, Int32 responsableId, string contrasenya)
        { UsuariAccions.modificarUsuari(id, dni, nom, cognoms, carrecId, responsableId, contrasenya); }

        public bool usuariHabilitat(Int32 usuariId)
        { return UsuariAccions.verificarAccesUsuari(usuariId); }

        public void activarUsuari(Int32 usuariId)
        { UsuariAccions.habilitarUsuari(usuariId); }

        public void desactivarUsuari(Int32 usuariId)
        { UsuariAccions.deshabilitarUsuari(usuariId); }

        public bool existeixUsuariPerDNI(string dni)
        { return UsuariAccions.existeixUsuariDNI(dni); }

        public Usuari buscarUsuariPerDni(string dniUsuari)
        { return UsuariAccions.buscarUsuariPerDNI(dniUsuari); }

        public List<Usuari> usuarisDeResponsable(Int32 responsableId)
        { return UsuariAccions.usuarisDeResponsable(responsableId); }

        public Usuari buscarUsuariPerId(Int32 id)
        { return UsuariAccions.buscarUsuariPerId(id); }

        public List<Usuari> llistarUsuaris()
        { return UsuariAccions.llistaDeUsuaris(); }

        public List<Usuari> nomsUsuariAmb(string paraula)
        { return UsuariAccions.buscarNomsqueContinguin(paraula); }

        public List<Usuari> cognomsUsuariAmb(string paraula)
        { return UsuariAccions.buscarCognomsqueContinguin(paraula); }

        public List<Usuari> nomIcognomsAmb(string paraulaNom, string paraulaCognoms)
        { return UsuariAccions.buscarNomCognomsqueContinguin(paraulaNom, paraulaCognoms); }

        public List<Usuari> dniAmb(string paraula)
        { return UsuariAccions.buscarUsuariDNIConte(paraula); }
        #endregion

        #region Fulls de despeses
        //Fulls de despeses
        public FullDespeses buscarFullObert(Int32 usuariId)
        { return FullsAccions.buscarFullObert(usuariId); }

        public FullDespeses obrirFullNou(Int32 usuariId)
        { return FullsAccions.crearFullNou(usuariId); }

        public DateTime solicitarPagamentFullDespeses(Int32 fullId)
        { return FullsAccions.solicitarPagamentFullDespeses(fullId); }

        public List<FullDespeses> buscarFullsPendentsDeResponsable(Int32 responsableId)
        { return FullsAccions.buscarFullsPendentsDeResponsable(responsableId); }

        public void rebutjarPagamentFull(Int32 idFull, string comentari)
        { FullsAccions.rebutjarFullDeDespeses(idFull, comentari); }

        public void acceptarPagamentFull(Int32 idFull)
        { FullsAccions.acceptarFullDeDespeses(idFull); }

        public List<FullDespeses> llistaFullsTancats(Int32 usuariId)
        { return FullsAccions.buscarFullsTancats(usuariId); }

        public string comentariDeFull(Int32 fullId)
        { return FullsAccions.comentariDeFull(fullId); }

        public void pagarFullsDespesesPendents(List<Int32> llistaFulls)
        { FullsAccions.pagarFullsDeDespeses(llistaFulls); }

        public List<FullDespeses> llistarFullsPendentsPagar()
        { return FullsAccions.llistaFullsPendentsPagament(); }
        #endregion

        #region Tipus de despeses
        //Tipus de despeses
        public Tipus buscarTipusPerNom(string nom)
        { return TipusAccions.buscarTipusPerNom(nom); }

        public Tipus buscarTipusPerId(Int32 tipusId)
        { return TipusAccions.buscarTipusPerId(tipusId); }

        public Tipus afegirTipusNou(string nom)
        { return TipusAccions.afegirTipus(nom); }

        public void modificarTipus(Int32 id, string nom)
        { TipusAccions.modificarTipus(id, nom); }

        public bool tipusHabilitat(Int32 id)
        { return TipusAccions.tipusHabilitat(id); }

        public void habilitarTipus(Int32 id)
        { TipusAccions.habilitarTipus(id); }

        public void deshabilitarTipus(Int32 id)
        { TipusAccions.deshabilitarTipus(id); }

        public List<Tipus> llistarTipusActius()
        { return TipusAccions.llistaDeTipusDisponibles(); }

        public List<Tipus> llistarTipus()
        { return TipusAccions.llistaDeTipus(); }
        #endregion

        #region Despeses
        //Despeses
        public bool verificarAdjunt(Int32 idDespesa)
        { return DespesesAccions.teAdjunt(idDespesa); }
        public List<Despesa> llistaDespesesDefull(Int32 fullId)
        { return DespesesAccions.buscarDespesesDeFull(fullId); }

        public Despesa afegirNovaDespesa(Int32 fullId, DateTime data, decimal import, Int32 tipusId, string comentari, string nomArxiu, byte[] adjunt)
        { return DespesesAccions.afegirDespesaNova(fullId, data, import, tipusId, comentari, nomArxiu, adjunt); }

        public void esborrarDespeses(List<Int32> id, List<bool> despesesAdjunt)
        { DespesesAccions.eliminarDespeses(id, despesesAdjunt); }

        public void denegarDespeses(List<Int32> despeses)
        { DespesesAccions.denegarDespeses(despeses); }

        public Despesa buscarDespesa(Int32 despesaId)
        { return DespesesAccions.buscarDespesaPerId(despesaId); }

        public void acceptarDespeses(List<Int32> despeses)
        { DespesesAccions.acceptarDespeses(despeses); }

        public void modificarDespesa(Int32 despesaId, DateTime data, decimal import, Int32 tipusId, string comentari, Int32 facturaId, string nomFactura, byte[] adjunt)
        { DespesesAccions.modificarDespesa(despesaId, data, import, tipusId, comentari, facturaId, nomFactura, adjunt); }

        public string buscarComentariDeDespesa(Int32 despesaId)
        { return DespesesAccions.comentariDeDespesa(despesaId); }
        #endregion

        #region Factures
        //Factures
        public string buscarNomDeFactura(Int32 despesaId)
        { return FacturesAccions.nomAdjunt(despesaId); }

        public Int32 buscarIdFactura(Int32 despesaId)
        { return FacturesAccions.idFacturaAmbIdDespesa(despesaId); }

        public byte[] buscarAdjuntDeDespesa(Int32 despesaId)
        { return FacturesAccions.obtenirAdjunt(despesaId); }
        #endregion

        #region Festius
        //Festius
        public List<Festiu> llistarFestius()
        { return FestiusAccions.llistaDeDiesFestius(); }

        public Festiu afegirFestiuNou(DateTime data, string descripcio)
        { return FestiusAccions.afegirFestiu(data, descripcio); }

        public void eliminarFestiu(DateTime data)
        { FestiusAccions.eliminarFestiu(data); }

        public bool verificarDiaFestiu(DateTime data)
        { return FestiusAccions.verificarFestivitat(data); }

        public List<DateTime> llistarDatesFestives()
        { return FestiusAccions.llistarDatesFestives(); }
        #endregion
    }
}
